<template>
  <div>
    <app-header />
    <nuxt />
    <app-footer v-if="isFooter" />
  </div>
</template>
<script>
import wc from 'which-country'
import { mapActions, mapGetters } from 'vuex'
import appHeader from '~/components/Header'
import appFooter from '~/components/Footer'

export default {
  name: 'AppLayout',
  components: {
    appHeader,
    appFooter
  },
  computed: {
    ...mapGetters({
      currency: 'currency/getCurrency'
    }),
    isFooter () {
      return !(this.$route.name && this.$route.name.includes('preview'))
    }
  },
  created () {
    if (process.browser) {
      navigator.geolocation.getCurrentPosition(this.successGeolocation, this.errorGeolocation)
    }
  },
  methods: {
    successGeolocation (position) {
      const latitude = position.coords.latitude
      const longitude = position.coords.longitude
      if (!this.currency) {
        this.setCurrency(wc([longitude, latitude]))
      }
    },
    errorGeolocation (position) {
      // eslint-disable-next-line no-console
      console.log('No location found')
    },
    ...mapActions({
      setCurrency: 'currency/SET_CURRENCY'
    })
  },
  head () {
    const i18nSeo = this.$nuxtI18nSeo()
    const title = this.$t('seo.title')
    const description = this.$t('seo.description')
    const keywords = this.$t('seo.keywords')
    const siteName = this.$t('seo.siteName')
    const url = process.env.BASE_URL + this.$route.path
    return {
      title,
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: description
        },
        {
          hid: 'og:title',
          property: 'og:title',
          content: title
        },
        {
          hid: 'og:description',
          property: 'og:description',
          content: description
        },
        {
          hid: 'keywords',
          name: 'keywords',
          content: keywords
        },
        {
          hid: 'og:url',
          property: 'og:url',
          content: url
        },
        {
          hid: 'og:site_name',
          property: 'og:site_name',
          content: siteName
        },
        ...i18nSeo.meta
      ],
      link: [
        ...i18nSeo.link
      ]
    }
  }
}
</script>
